# -*- coding: utf-8 -*-
## PloneChat
## Copyright (C)2005 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""
Installation module for PloneChat
"""
__version__ = "$Revision: 19448 $"
# $Source: /cvsroot/ingeniweb/PloneChat/Extensions/Attic/Install.py,v $
# $Id: Install.py 19448 2006-02-17 14:27:26Z cbosse $
__docformat__ = 'restructuredtext'

# Python imports
from StringIO import StringIO

# CMF imports
from Products.CMFCore.utils import getToolByName

# AT imports
from Products.Archetypes import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin

# Product imports
from Products.PloneChat.config import *
from Products.PloneChat import PloneChatTool

def setPermissions(self, out):
    """
    setPermissions(self) => Set standard permissions / roles
    """
    # As a default behavior, newly-created permissions are granted to owner and manager.
    # To change this, just comment this code and grab back the code commented below to
    # make it suit your needs.
    for perm in PERMS_LIST:
        self.manage_permission(perm, ('Manager', 'Owner'), acquire=1)

    # Set special permissions
    self.manage_permission(PloneChat_restrictedChatPermission, ('Member', 'Manager', 'Owner', ), acquire=1)
    self.manage_permission(PloneChat_moderatePermission, ('Reviewer', 'Manager', ), acquire=1)
    out.write("Reseted default permissions\n")

def installTool(self, out):
    tool = getToolByName(self, 'portal_plone_chat', None)
    if tool is None:
        addTool = self.manage_addProduct['PloneChat'].manage_addTool
        addTool('PloneChatTool')
        tool = getattr(self, PloneChatTool.PloneChatTool.id, None)
        tool.setSqlConnectorId()
        out.write('PloneChat tool installed')

def install(self):
    """
    """
    out = StringIO()

    # install types
    typeInfo = listTypes(PROJECTNAME)
    installTypes(self, out, typeInfo, PROJECTNAME)

    # install skin
    install_subskin(self, out, GLOBALS)

    # Install permissions
    setPermissions(self, out)

    # Install tool
    installTool(self, out)

    # Add portal types to use portal factory
    pftool = getToolByName(self, 'portal_factory')
    pftool.manage_setPortalFactoryTypes(listOfTypeIds=('PloneChat',))

    out.write('Installation completed.\n')
    return out.getvalue()

def uninstall(self):
    """
    """
    out = StringIO()
    out.write('Uninstallation completed.\n')
    return out.getvalue()
