# -*- coding: utf-8 -*-
## PloneChat
## Copyright (C)2005 Ingeniweb

## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.

## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program; see the file COPYING. If not, write to the
## Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""
PloneChat product
"""
__version__ = "$Revision: 19335 $"
# $Source: /cvsroot/ingeniweb/PloneChat/__init__.py,v $
# $Id: __init__.py 19335 2006-02-15 12:33:33Z cbosse $
__docformat__ = 'restructuredtext'

# CMF imports
from Products.CMFCore.DirectoryView import registerDirectory
from Products.CMFCore import CMFCorePermissions
from Products.CMFCore.utils import ContentInit, ToolInit

# AT imports
from Products.Archetypes.public import process_types, listTypes

# Product import
from Products.PloneChat.config import *
from Products.PloneChat.content import *

registerDirectory(SKINS_DIR, GLOBALS)

# Initialization method
def initialize(context):
    listOfTypes = listTypes(PROJECTNAME)
    content_types, constructors, ftis = process_types(listOfTypes, PROJECTNAME)
    
    ContentInit('%s Content' % PROJECTNAME,
                content_types = tuple(content_types),
                permission = PloneChat_addPermission,
                extra_constructors = tuple(constructors),
                fti = ftis,
                ).initialize(context)

    # PloneChat tool
    from Products.PloneChat.PloneChatTool import PloneChatTool

    tool = ToolInit('%s Tool' % PROJECTNAME,
                    tools=(PloneChatTool,),
                    product_name=PROJECTNAME,
                    icon='tool.gif')
    tool.initialize(context)
